import { WidgetDesignation, WidgetPropertyInternal, WidgetState } from "../orchestrator/orchestrator.types";
import { IWidgetRegistration } from "../orchestrator/IWidgetRegistration";
import { IWidgetInstanceInternal } from "../orchestrator/IWidgetInstanceInternal";
import { Data } from "../orchestrator/VisibilityTelemetry";
import { WidgetApi } from "../orchestrator/WidgetApi";
import { WidgetProperty } from "../apis/api.interfaces";
export declare class MockWidgetInstanceInternal implements IWidgetInstanceInternal {
    widgetRegistration: IWidgetRegistration;
    readonly widgetDesignation: WidgetDesignation;
    widgetState: WidgetState;
    widgetErrorStateReason: string;
    widgetErrorCode: number;
    widgetIconUri: string;
    isLoadForAddedInstancePending: boolean;
    softRefreshRequested: boolean;
    telemetry: Data.Telemetry;
    isCustomElementDefined: boolean;
    isPlatform: boolean;
    boardView: string;
    instanceId: number;
    indexedDBInstanceId: number;
    accountId: string;
    widgetDefinitionId: string;
    tryGetApi<T>(apiName: string, minVersion: number, targetVersion: number): T | null;
    set widgetId(widgetId: string);
    get widgetId(): string;
    set widgetInstanceId(widgetInstanceId: string);
    get widgetInstanceId(): string;
    setApi(apiName: string, version: number, createApi: WidgetApi | ((widgetInstance: IWidgetInstanceInternal) => WidgetApi)): void;
    getUriForResource(resource: string): string;
    updateRegistration(registration: IWidgetRegistration): Promise<void>;
    refreshContent(): Promise<void>;
    suspend(): Promise<void>;
    resume(): Promise<void>;
    getAllWidgetProperties(): Map<WidgetPropertyInternal | WidgetProperty, any>;
    getWidgetProperty(key: WidgetPropertyInternal | WidgetProperty): any;
    setWidgetProperty(key: WidgetPropertyInternal | WidgetProperty, value: any): Promise<any>;
    addStateChangeListener(listener: (widgetInstance: IWidgetInstanceInternal, previousState: WidgetState, currentState: WidgetState) => void): void;
    removeStateChangeListener(listener: (widgetInstance: IWidgetInstanceInternal, previousState: WidgetState, currentState: WidgetState) => void): void;
    widgetInitializationPromise(): Promise<void>;
    signalAPIInitialization(): void;
    addExecuteActionListener(listener: (actionProps: Array<string>, instanceId: number, widgetInstanceId: string, widgetRegistration: IWidgetRegistration) => void): void;
    removeExecuteActionListener(listener: (actionProps: Array<string>, instanceId: number, widgetInstanceId: string, widgetRegistration: IWidgetRegistration) => void): void;
    addSubmitActionListener(listener: (actionProps: Array<string>, instanceId: number, widgetInstanceId: string, widgetRegistration: IWidgetRegistration) => void): void;
    removeSubmitActionListener(listener: (actionProps: Array<string>, instanceId: number, widgetInstanceId: string, widgetRegistration: IWidgetRegistration) => void): void;
    notifyExecuteAction(actionProps: Array<string>): void;
    notifySubmitAction(actionProps: Array<string>): void;
    isOutlookWidget(): boolean;
}
